Module org.hsqldb
Package org.hsqldb.jdbc

## Class JDBCPreparedStatement

- java.lang.Object
- - org.hsqldb.jdbc.JDBCPreparedStatement

- All Implemented Interfaces:
    `java.lang.AutoCloseable`, `java.sql.PreparedStatement`, `java.sql.Statement`, `java.sql.Wrapper`
  Direct Known Subclasses:
    `JDBCCallableStatement`

      public class JDBCPreparedStatement
      extends java.lang.Object
      implements java.sql.PreparedStatement

  An object that represents a precompiled SQL statement.

  A SQL statement is precompiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

  Note: The setter methods (`setShort`, `setString`, and so on) for setting IN parameter values must specify types that are compatible with the defined SQL type of the input parameter. For instance, if the IN parameter has SQL type `INTEGER`, then the method `setInt` should be used.

  If arbitrary parameter type conversions are required, the method `setObject` should be used with a target SQL type.

  In the following example of setting a parameter, `con` represents an active connection:

         BigDecimal sal = new BigDecimal("153833.00");
         PreparedStatement pstmt = con.prepareStatement("UPDATE EMPLOYEES
                                           SET SALARY = ? WHERE ID = ?");
         pstmt.setBigDecimal(1, sal);
         pstmt.setInt(2, 110592);

  HSQLDB-Specific Information:

  From version 2.0, the implementation meets the JDBC specification requirement that any existing ResultSet is closed when execute() or executeQuery() methods are called. The connection property close_result=true is required for this behaviour.

  JDBCPreparedStatement objects are backed by a true compiled parametric representation. Hence, there are now significant performance gains to be had by using a JDBCPreparedStatement object in preference to a JDBCStatement object when a short-running SQL statement is to be executed more than once.

  When it can be otherwise avoided, it should be considered poor practice to fully prepare (construct), parameterize, execute, fetch and close a JDBCParameterMetaData object for each execution cycle. Indeed, because the prepare and execute phases both represent a round-trip to the engine, this practice is likely to be noticeably less performant for short-running statements (and possibly even orders of magnitude less performant over network connections for short-running statements) than the equivalent process using JDBCStatement objects, albeit far more convenient, less error prone and certainly much less resource-intensive, especially when large binary and character values are involved, due to the optimized parameterization facility.

  Instead, when developing an application that is not totally oriented toward the execution of ad hoc SQL, it is recommended to expend some effort toward identifying the SQL statements that are good candidates for regular reuse and adapting the structure of the application accordingly. Often, this is done by recording the text of candidate SQL statements in an application resource object (which has the nice side-benefit of isolating and hiding differences in SQL dialects across different drivers) and caching for possible reuse the PreparedStatement objects derived from the recorded text.

  Starting with 2.0, when built under a JDBC 4 environment, statement caching can be transparently enabled or disabled on a statement-by-statement basis by invoking setPoolable(true | false), respectively, upon Statement objects of interest.

  Multi thread use:

  A PreparedStatement object is stateful and should not normally be shared by multiple threads. If it has to be shared, the calls to set the parameters, calls to add batch statements, the execute call and any post-execute calls should be made within a block synchronized on the PreparedStatement Object.

  (fredt@users)
  (campbell-burnet@users)

  Since:
    JDK 1.1, HSQLDB 1.9.0
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
  See Also:
    `JDBCConnection.prepareStatement(java.lang.String)`, `JDBCResultSet`

- - ### Field Summary

    - ### Fields inherited from interface java.sql.Statement

      `CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addBatch()` | Adds a set of parameters to this `PreparedStatement` object's batch of commands.
    `void` | `addBatch​(java.lang.String sql)` | This method should always throw if called for a PreparedStatement or CallableStatement.
    `void` | `cancel()` | Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
    `void` | `clearBatch()` | Empties this `Statement` object's current list of SQL commands.
    `void` | `clearParameters()` | Clears the current parameter values immediately.
    `void` | `clearWarnings()` | Clears all the warnings reported on this `Statement` object.
    `void` | `close()` | Does the specialized work required to free this object's resources and that of its parent class.
    `void` | `closeOnCompletion()` | Specifies that this `Statement` will be closed when all its dependent result sets are closed.
    `boolean` | `execute()` | Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement.
    `boolean` | `execute​(java.lang.String sql)` | This method should always throw if called for a PreparedStatement or CallableStatement.
    `boolean` | `execute​(java.lang.String sql, int autoGeneratedKeys)` |
    `boolean` | `execute​(java.lang.String sql, int[] columnIndexes)` |
    `boolean` | `execute​(java.lang.String sql, java.lang.String[] columnNames)` |
    `int[]` | `executeBatch()` | Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
    `long[]` | `executeLargeBatch()` | Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
    `long` | `executeLargeUpdate()` | Executes the SQL statement in this `PreparedStatement` object, which must be an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
    `java.sql.ResultSet` | `executeQuery()` | Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.
    `java.sql.ResultSet` | `executeQuery​(java.lang.String sql)` | This method should always throw if called for a PreparedStatement or CallableStatement.
    `int` | `executeUpdate()` | Executes the SQL statement in this `PreparedStatement` object, which must be an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
    `int` | `executeUpdate​(java.lang.String sql)` | This method should always throw if called for a PreparedStatement or CallableStatement.
    `int` | `executeUpdate​(java.lang.String sql, int autoGeneratedKeys)` | Statement methods that must be overridden in this class and throw an exception.
    `int` | `executeUpdate​(java.lang.String sql, int[] columnIndexes)` |
    `int` | `executeUpdate​(java.lang.String sql, java.lang.String[] columnNames)` |
    `java.sql.Connection` | `getConnection()` | Retrieves the `Connection` object that produced this `Statement` object.
    `int` | `getFetchDirection()` | Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
    `int` | `getFetchSize()` | Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
    `java.sql.ResultSet` | `getGeneratedKeys()` | Retrieves any auto-generated keys created as a result of executing this `Statement` object.
    `long` | `getLargeMaxRows()` | Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
    `long` | `getLargeUpdateCount()` | Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
    `int` | `getMaxFieldSize()` | Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
    `int` | `getMaxRows()` | Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
    `java.sql.ResultSetMetaData` | `getMetaData()` | Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.
    `boolean` | `getMoreResults()` | Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
    `boolean` | `getMoreResults​(int current)` | Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
    `java.sql.ParameterMetaData` | `getParameterMetaData()` | Retrieves the number, types and properties of this `PreparedStatement` object's parameters.
    `org.hsqldb.result.ResultMetaData` | `getParameterMetaDataDirect()` |
    `int` | `getQueryTimeout()` | Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
    `java.sql.ResultSet` | `getResultSet()` | Retrieves the current result as a `ResultSet` object.
    `int` | `getResultSetConcurrency()` | Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
    `int` | `getResultSetHoldability()` | Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
    `JDBCResultSetMetaData` | `getResultSetMetaData()` |
    `int` | `getResultSetType()` | Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
    `java.lang.String` | `getSQL()` |
    `long` | `getStatementID()` |
    `int` | `getUpdateCount()` | Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
    `java.sql.SQLWarning` | `getWarnings()` | Retrieves the first warning reported by calls on this `Statement` object.
    `boolean` | `isClosed()` | Retrieves whether this `Statement` object has been closed.
    `boolean` | `isCloseOnCompletion()` | Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
    `boolean` | `isPoolable()` | Returns a value indicating whether the `Statement` is poolable or not.
    `boolean` | `isRowCount()` |
    `boolean` | `isWrapperFor​(java.lang.Class<?> iface)` | Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
    `void` | `setArray​(int parameterIndex, java.sql.Array x)` | Sets the designated parameter to the given `java.sql.Array` object.
    `void` | `setAsciiStream​(int parameterIndex, java.io.InputStream x)` | Sets the designated parameter to the given input stream.
    `void` | `setAsciiStream​(int parameterIndex, java.io.InputStream x, int length)` | Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setAsciiStream​(int parameterIndex, java.io.InputStream x, long length)` | Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setBigDecimal​(int parameterIndex, java.math.BigDecimal x)` | Sets the designated parameter to the given `java.math.BigDecimal` value.
    `void` | `setBinaryStream​(int parameterIndex, java.io.InputStream x)` | Sets the designated parameter to the given input stream.
    `void` | `setBinaryStream​(int parameterIndex, java.io.InputStream x, int length)` | Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setBinaryStream​(int parameterIndex, java.io.InputStream x, long length)` | Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setBlob​(int parameterIndex, java.io.InputStream inputStream)` | Sets the designated parameter to a `InputStream` object.
    `void` | `setBlob​(int parameterIndex, java.io.InputStream inputStream, long length)` | Sets the designated parameter to a `InputStream` object.
    `void` | `setBlob​(int parameterIndex, java.sql.Blob x)` | Sets the designated parameter to the given `java.sql.Blob` object.
    `void` | `setBoolean​(int parameterIndex, boolean x)` | Sets the designated parameter to the given Java `boolean` value.
    `void` | `setByte​(int parameterIndex, byte x)` | Sets the designated parameter to the given Java `byte` value.
    `void` | `setBytes​(int parameterIndex, byte[] x)` | Sets the designated parameter to the given Java array of bytes.
    `void` | `setCharacterStream​(int parameterIndex, java.io.Reader reader)` | Sets the designated parameter to the given `Reader` object.
    `void` | `setCharacterStream​(int parameterIndex, java.io.Reader reader, int length)` | Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
    `void` | `setCharacterStream​(int parameterIndex, java.io.Reader reader, long length)` | Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
    `void` | `setClob​(int parameterIndex, java.io.Reader reader)` | Sets the designated parameter to a `Reader` object.
    `void` | `setClob​(int parameterIndex, java.io.Reader reader, long length)` | Sets the designated parameter to a `Reader` object.
    `void` | `setClob​(int parameterIndex, java.sql.Clob x)` | Sets the designated parameter to the given `java.sql.Clob` object.
    `void` | `setCursorName​(java.lang.String name)` | Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
    `void` | `setDate​(int parameterIndex, java.sql.Date x)` | Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application.
    `void` | `setDate​(int parameterIndex, java.sql.Date x, java.util.Calendar cal)` | Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
    `void` | `setDouble​(int parameterIndex, double x)` | Sets the designated parameter to the given Java `double` value.
    `void` | `setEscapeProcessing​(boolean enable)` | Sets escape processing on or off.
    `void` | `setFetchDirection​(int direction)` | Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
    `void` | `setFetchSize​(int rows)` | Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement`.
    `void` | `setFloat​(int parameterIndex, float x)` | Sets the designated parameter to the given Java `float` value.
    `void` | `setInt​(int parameterIndex, int x)` | Sets the designated parameter to the given Java `int` value.
    `void` | `setLargeMaxRows​(long max)` | Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
    `void` | `setLong​(int parameterIndex, long x)` | Sets the designated parameter to the given Java `long` value.
    `void` | `setMaxFieldSize​(int max)` | Sets the limit for the maximum number of bytes in a `ResultSet` Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
    `void` | `setMaxRows​(int max)` | Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number.
    `void` | `setNCharacterStream​(int parameterIndex, java.io.Reader value)` | Sets the designated parameter to a `Reader` object.
    `void` | `setNCharacterStream​(int parameterIndex, java.io.Reader value, long length)` | Sets the designated parameter to a `Reader` object.
    `void` | `setNClob​(int parameterIndex, java.io.Reader reader)` | Sets the designated parameter to a `Reader` object.
    `void` | `setNClob​(int parameterIndex, java.io.Reader reader, long length)` | Sets the designated parameter to a `Reader` object.
    `void` | `setNClob​(int parameterIndex, java.sql.NClob value)` | Sets the designated parameter to a `java.sql.NClob` object.
    `void` | `setNString​(int parameterIndex, java.lang.String value)` | Sets the designated parameter to the given `String` object.
    `void` | `setNull​(int parameterIndex, int sqlType)` | Sets the designated parameter to SQL `NULL`.
    `void` | `setNull​(int parameterIndex, int sqlType, java.lang.String typeName)` | Sets the designated parameter to SQL `NULL`.
    `void` | `setObject​(int parameterIndex, java.lang.Object x)` | Sets the value of the designated parameter using the given object.
    `void` | `setObject​(int parameterIndex, java.lang.Object x, int targetSqlType)` | Sets the value of the designated parameter with the given object.
    `void` | `setObject​(int parameterIndex, java.lang.Object x, int targetSqlType, int scaleOrLength)` | Sets the value of the designated parameter with the given object.
    `void` | `setObject​(int parameterIndex, java.lang.Object x, java.sql.SQLType targetSqlType)` | Sets the value of the designated parameter with the given object.
    `void` | `setObject​(int parameterIndex, java.lang.Object x, java.sql.SQLType targetSqlType, int scaleOrLength)` | Sets the value of the designated parameter with the given object.
    `void` | `setPoolable​(boolean poolable)` | Requests that a `Statement` be pooled or not pooled.
    `void` | `setQueryTimeout​(int seconds)` | Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.
    `void` | `setRef​(int parameterIndex, java.sql.Ref x)` | Sets the designated parameter to the given `REF(<structured-type>)` value.
    `void` | `setRowId​(int parameterIndex, java.sql.RowId x)` | Sets the designated parameter to the given `java.sql.RowId` object.
    `void` | `setShort​(int parameterIndex, short x)` | Sets the designated parameter to the given Java `short` value.
    `void` | `setSQLXML​(int parameterIndex, java.sql.SQLXML xmlObject)` | Sets the designated parameter to the given `java.sql.SQLXML` object.
    `void` | `setString​(int parameterIndex, java.lang.String x)` | Sets the designated parameter to the given Java `String` value.
    `void` | `setTime​(int parameterIndex, java.sql.Time x)` | Sets the designated parameter to the given `java.sql.Time` value.
    `void` | `setTime​(int parameterIndex, java.sql.Time x, java.util.Calendar cal)` | Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
    `void` | `setTimestamp​(int parameterIndex, java.sql.Timestamp x)` | Sets the designated parameter to the given `java.sql.Timestamp` value.
    `void` | `setTimestamp​(int parameterIndex, java.sql.Timestamp x, java.util.Calendar cal)` | Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
    `void` | `setUnicodeStream​(int parameterIndex, java.io.InputStream x, int length)` | Deprecated. Use `setCharacterStream`
    `void` | `setURL​(int parameterIndex, java.net.URL x)` | Sets the designated parameter to the given `java.net.URL` value.
    `java.lang.String` | `toString()` | Retrieves a String representation of this object.
    `<T> T` | `unwrap​(java.lang.Class<T> iface)` | Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.sql.Statement

      `closeOnCompletion, enquoteIdentifier, enquoteLiteral, enquoteNCharLiteral, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, isCloseOnCompletion, isSimpleIdentifier`

- - ### Method Detail

    - #### executeQuery

          public java.sql.ResultSet executeQuery()
                                          throws java.sql.SQLException

      Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.
      Specified by:
        `executeQuery` in interface `java.sql.PreparedStatement`
      Returns:
        a `ResultSet` object that contains the data produced by the query; never `null`
      Throws:
        `java.sql.SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or the SQL statement does not return a `ResultSet` object
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`

    - #### executeUpdate

          public int executeUpdate()
                            throws java.sql.SQLException

      Executes the SQL statement in this `PreparedStatement` object, which must be an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
      Specified by:
        `executeUpdate` in interface `java.sql.PreparedStatement`
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or the SQL statement returns a `ResultSet` object
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`

    - #### setNull

          public void setNull​(int parameterIndex,
                              int sqlType)
                       throws java.sql.SQLException

      Sets the designated parameter to SQL `NULL`.

      Note: You must specify the parameter's SQL type.

      HSQLDB-Specific Information:

      HSQLDB currently ignores the sqlType argument.
      Specified by:
        `setNull` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `sqlType` - the SQL type code defined in `java.sql.Types`
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type

    - #### setBoolean

          public void setBoolean​(int parameterIndex,
                                 boolean x)
                          throws java.sql.SQLException

      Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` or `BOOLEAN` value when it sends it to the database.

      HSQLDB-Specific Information:

      HSQLDB supports BOOLEAN type for boolean values. This method can also be used to set the value of a parameter of the SQL type BIT(1), which is a bit string consisting of a 0 or 1.
      Specified by:
        `setBoolean` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setByte

          public void setByte​(int parameterIndex,
                              byte x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.
      Specified by:
        `setByte` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setShort

          public void setShort​(int parameterIndex,
                               short x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.
      Specified by:
        `setShort` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setInt

          public void setInt​(int parameterIndex,
                             int x)
                      throws java.sql.SQLException

      Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.
      Specified by:
        `setInt` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setLong

          public void setLong​(int parameterIndex,
                              long x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.
      Specified by:
        `setLong` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setFloat

          public void setFloat​(int parameterIndex,
                               float x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `REAL` value when it sends it to the database.

      HSQLDB-Specific Information:

      Since 1.7.1, HSQLDB handles Java positive/negative Infinity and NaN `float` values consistent with the Java Language Specification; these special values are now correctly stored to and retrieved from the database.
      Specified by:
        `setFloat` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setDouble

          public void setDouble​(int parameterIndex,
                                double x)
                         throws java.sql.SQLException

      Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

      HSQLDB-Specific Information:

      Since 1.7.1, HSQLDB handles Java positive/negative Infinity and NaN `double` values consistent with the Java Language Specification; these special values are now correctly stored to and retrieved from the database.
      Specified by:
        `setDouble` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setBigDecimal

          public void setBigDecimal​(int parameterIndex,
                                    java.math.BigDecimal x)
                             throws java.sql.SQLException

      Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.
      Specified by:
        `setBigDecimal` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setString

          public void setString​(int parameterIndex,
                                java.lang.String x)
                         throws java.sql.SQLException

      Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

      HSQLDB-Specific Information:

      Including 2.0, HSQLDB represents all XXXCHAR values internally as java.lang.String objects; there is no appreciable difference between CHAR, VARCHAR and LONGVARCHAR.
      Specified by:
        `setString` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setBytes

          public void setBytes​(int parameterIndex,
                               byte[] x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

      HSQLDB-Specific Information:

      Including 2.0, HSQLDB represents all XXXBINARY values the same way internally; there is no appreciable difference between BINARY, VARBINARY and LONGVARBINARY as far as JDBC is concerned.
      Specified by:
        `setBytes` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setDate

          public void setDate​(int parameterIndex,
                              java.sql.Date x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application. The driver converts this to an SQL `DATE` value when it sends it to the database.

      HSQLDB-Specific Information:

      When a setXXX method is used to set a parameter of type TIMESTAMP WITH TIME ZONE or TIME WITH TIME ZONE the time zone of the client application is used as time zone
      Specified by:
        `setDate` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setTime

          public void setTime​(int parameterIndex,
                              java.sql.Time x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

      HSQLDB-Specific Information:

      When a setXXX method is used to set a parameter of type TIMESTAMP WITH TIME ZONE or TIME WITH TIME ZONE the time zone of the client application is used as time zone
      Specified by:
        `setTime` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setTimestamp

          public void setTimestamp​(int parameterIndex,
                                   java.sql.Timestamp x)
                            throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

      HSQLDB-Specific Information:

      When a setXXX method is used to set a parameter of type TIMESTAMP WITH TIME ZONE or TIME WITH TIME ZONE the time zone of the client application is used as time zone.

      When this method is used to set a parameter of type TIME or TIME WITH TIME ZONE, then the nanosecond value of the Timestamp object will be used if the TIME parameter accepts fractional seconds.

      Specified by:
        `setTimestamp` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setAsciiStream

          public void setAsciiStream​(int parameterIndex,
                                     java.io.InputStream x,
                                     int length)
                              throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      From HSQLDB 2.0 this method uses the US-ASCII character encoding to convert bytes from the stream into the characters of a String.

      This method does not use streaming to send the data, whether the target is a CLOB or other binary object.

      For long streams (larger than a few megabytes) with CLOB targets, it is more efficient to use a version of setCharacterStream which takes the a length parameter.

      Specified by:
        `setAsciiStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the Java input stream that contains the ASCII parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setUnicodeStream

          @Deprecated
          public void setUnicodeStream​(int parameterIndex,
                                       java.io.InputStream x,
                                       int length)
                                throws java.sql.SQLException

      Deprecated.
      Use `setCharacterStream`
      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large Unicode value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from Unicode to the database char format. The byte format of the Unicode stream must be a Java UTF-8, as defined in the Java Virtual Machine Specification.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      Starting with 2.0, this method behaves according to the JDBC4 specification (the stream is treated as though it has UTF-8 encoding. This method is deprecated: please use setCharacterStream(...) instead.
      Specified by:
        `setUnicodeStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - a `java.io.InputStream` object that contains the Unicode parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

    - #### setBinaryStream

          public void setBinaryStream​(int parameterIndex,
                                      java.io.InputStream x,
                                      int length)
                               throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      Since 1.7.2, this method works according to the standard.
      Specified by:
        `setBinaryStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the java input stream which contains the binary parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### clearParameters

          public void clearParameters()
                               throws java.sql.SQLException

      Clears the current parameter values immediately.

      In general, parameter values remain in force for repeated use of a statement. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling the method `clearParameters`.

      Specified by:
        `clearParameters` in interface `java.sql.PreparedStatement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`

    - #### setObject

          public void setObject​(int parameterIndex,
                                java.lang.Object x,
                                int targetSqlType)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. This method is similar to `setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength)`, except that it assumes a scale of zero.

      HSQLDB-Specific Information:

      Since 1.7.2, this method supports conversions listed in the conversion table B-5 of the JDBC 3 specification.
      Specified by:
        `setObject` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the object containing the input parameter value
        `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed PreparedStatement
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
      See Also:
        `Types`

    - #### setObject

          public void setObject​(int parameterIndex,
                                java.lang.Object x)
                         throws java.sql.SQLException

      Sets the value of the designated parameter using the given object.

      The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

      Note that this method may be used to pass database- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, `RowId`, `SQLXML` or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

      Note: Not all databases allow for a non-typed Null to be sent to the backend. For maximum portability, the `setNull` or the `setObject(int parameterIndex, Object x, int sqlType)` method should be used instead of `setObject(int parameterIndex, Object x)`.

      Note: This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

      HSQLDB-Specific Information:

      Since 1.7.2, this method supports conversions listed in the conversion table B-5 of the JDBC 3 specification.
      Specified by:
        `setObject` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the object containing the input parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or the type of the given object is ambiguous

    - #### execute

          public boolean execute()
                          throws java.sql.SQLException

      Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement. Some prepared statements return multiple results; the `execute` method handles these complex statements as well as the simpler form of statements handled by the methods `executeQuery` and `executeUpdate`.

      The `execute` method returns a `boolean` to indicate the form of the first result. You must call either the method `getResultSet` or `getUpdateCount` to retrieve the result; you must call `getMoreResults` to move to any subsequent result(s).

      HSQLDB-Specific Information:

      If the statement is a call to a PROCEDURE, it may return multiple fetchable results.
      Specified by:
        `execute` in interface `java.sql.PreparedStatement`
      Returns:
        `true` if the first result is a `ResultSet` object; `false` if the first result is an update count or there is no result
      Throws:
        `java.sql.SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or an argument is supplied to this method
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      See Also:
        `JDBCStatement.execute(java.lang.String)`, `JDBCStatement.getResultSet()`, `JDBCStatement.getUpdateCount()`, `JDBCStatement.getMoreResults()`

    - #### addBatch

          public void addBatch()
                        throws java.sql.SQLException

      Adds a set of parameters to this `PreparedStatement` object's batch of commands.

      HSQLDB-Specific Information:

      Since 1.7.2, this feature is supported.
      Specified by:
        `addBatch` in interface `java.sql.PreparedStatement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.2
      See Also:
        `JDBCStatement.addBatch(java.lang.String)`

    - #### setCharacterStream

          public void setCharacterStream​(int parameterIndex,
                                         java.io.Reader reader,
                                         int length)
                                  throws java.sql.SQLException

      Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      From HSQLDB 2.0 this method uses streaming to send data when the target is a CLOB.

      HSQLDB represents CHARACTER and related SQL types as UTF16 Unicode internally, so this method does not perform any conversion.

      Specified by:
        `setCharacterStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `reader` - the `java.io.Reader` object that contains the Unicode data
        `length` - the number of characters in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.2

    - #### setRef

          public void setRef​(int parameterIndex,
                             java.sql.Ref x)
                      throws java.sql.SQLException

      Sets the designated parameter to the given `REF(<structured-type>)` value. The driver converts this to an SQL `REF` value when it sends it to the database.

      HSQLDB-Specific Information:

      Including 2.0 HSQLDB does not support the SQL REF type. Calling this method throws an exception.
      Specified by:
        `setRef` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - an SQL `REF` value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### setBlob

          public void setBlob​(int parameterIndex,
                              java.sql.Blob x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.

      HSQLDB-Specific Information:

      For parameters of type Blob, setBlob works normally.

      In addition since 1.7.2, setBlob is supported for BINARY and VARBINARY parameters. In this context, the Blob object is hard-limited to those of length less than or equal to Integer.MAX_VALUE. In practice, soft limits such as available heap and maximum disk usage per file (such as the transaction log) dictate a much smaller maximum length.

      For BINARY and VARBINARY parameter types setBlob(i,x) is roughly equivalent (null and length handling not shown) to:

           setBinaryStream(i, x.getBinaryStream(), (int) x.length());

      Specified by:
        `setBlob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - a `Blob` object that maps an SQL `BLOB` value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### setClob

          public void setClob​(int parameterIndex,
                              java.sql.Clob x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.

      HSQLDB-Specific Information:

      For parameters of type Clob, setClob works normally.

      In addition since 1.7.2, setClob is supported for CHARACTER and VARCHAR parameters. In this context, the Clob object is hard-limited to those of length less than or equal to Integer.MAX_VALUE. In practice, soft limits such as available heap and maximum disk usage per file (such as the transaction log) dictate a much smaller maximum length.

      For CHARACTER and VARCHAR parameter types setClob(i,x) is roughly equivalent (null and length handling not shown) to:

           setCharacterStream(i, x.getCharacterStream(), (int) x.length());

      Specified by:
        `setClob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - a `Clob` object that maps an SQL `CLOB` value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### setArray

          public void setArray​(int parameterIndex,
                               java.sql.Array x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Array` object. The driver converts this to an SQL `ARRAY` value when it sends it to the database.

      HSQLDB-Specific Information:

      From version 2.0, HSQLDB supports the SQL ARRAY type.
      Specified by:
        `setArray` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - an `Array` object that maps an SQL `ARRAY` value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### getMetaData

          public java.sql.ResultSetMetaData getMetaData()
                                                 throws java.sql.SQLException

      Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.

      Because a `PreparedStatement` object is precompiled, it is possible to know about the `ResultSet` object that it will return without having to execute it. Consequently, it is possible to invoke the method `getMetaData` on a `PreparedStatement` object rather than waiting to execute it and then invoking the `ResultSet.getMetaData` method on the `ResultSet` object that is returned.

      NOTE: Using this method may be expensive for some drivers due to the lack of underlying DBMS support.

      HSQLDB-Specific Information:

      Since 1.7.2, this feature is supported and is inexpensive as it is backed by underlying DBMS support. If the statement generates an update count, then null is returned.
      Specified by:
        `getMetaData` in interface `java.sql.PreparedStatement`
      Returns:
        the description of a `ResultSet` object's columns or `null` if the driver cannot return a `ResultSetMetaData` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### setDate

          public void setDate​(int parameterIndex,
                              java.sql.Date x,
                              java.util.Calendar cal)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.
      Specified by:
        `setDate` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
        `cal` - the `Calendar` object the driver will use to construct the date
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.2

    - #### setTime

          public void setTime​(int parameterIndex,
                              java.sql.Time x,
                              java.util.Calendar cal)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

      HSQLDB-Specific Information:

      When a setXXX method is used to set a parameter of type TIMESTAMP WITH TIME ZONE or TIME WITH TIME ZONE the time zone (including Daylight Saving Time) of the Calendar is used as time zone for the value.
      Specified by:
        `setTime` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
        `cal` - the `Calendar` object the driver will use to construct the time
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.2

    - #### setTimestamp

          public void setTimestamp​(int parameterIndex,
                                   java.sql.Timestamp x,
                                   java.util.Calendar cal)
                            throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

      HSQLDB-Specific Information:

      When a setXXX method is used to set a parameter of type TIMESTAMP WITH TIME ZONE or TIME WITH TIME ZONE the time zone (including Daylight Saving Time) of the Calendar is used as time zone.

      In this case, if the Calendar argument is null, then the default Calendar for the clients JVM is used as the Calendar

      When this method is used to set a parameter of type TIME or TIME WITH TIME ZONE, then the nanosecond value of the Timestamp object is used if the TIME parameter accepts fractional seconds.

      Specified by:
        `setTimestamp` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
        `cal` - the `Calendar` object the driver will use to construct the timestamp
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.2

    - #### setNull

          public void setNull​(int parameterIndex,
                              int sqlType,
                              java.lang.String typeName)
                       throws java.sql.SQLException

      Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

      Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

      HSQLDB-Specific Information:

      HSQLDB simply ignores the sqlType and typeName arguments.
      Specified by:
        `setNull` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `sqlType` - a value from `java.sql.Types`
        `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or REF
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type or if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### executeBatch

          public int[] executeBatch()
                             throws java.sql.SQLException

      Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:
      1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
      2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

         If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

      3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

      A driver is not required to implement this method. The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to process commands in a batch update after a `BatchUpdateException` object has been thrown.

      HSQLDB-Specific Information:

      Starting with HSQLDB 1.7.2, this feature is supported.

      HSQLDB stops execution of commands in a batch when one of the commands results in an exception. The size of the returned array equals the number of commands that were executed successfully.

      Specified by:
        `executeBatch` in interface `java.sql.Statement`
      Returns:
        an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
      Since:
        JDK 1.3
      See Also:
        `addBatch()`, `DatabaseMetaData.supportsBatchUpdates()`

    - #### setEscapeProcessing

          public void setEscapeProcessing​(boolean enable)
                                   throws java.sql.SQLException

      Sets escape processing on or off.

      HSQLDB-Specific Information:

      As per JDBC spec, calling this method has no effect.
      Specified by:
        `setEscapeProcessing` in interface `java.sql.Statement`
      Parameters:
        `enable` - `true` to enable escape processing; `false` to disable it
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### addBatch

          public void addBatch​(java.lang.String sql)
                        throws java.sql.SQLException

      This method should always throw if called for a PreparedStatement or CallableStatement.
      Specified by:
        `addBatch` in interface `java.sql.Statement`
      Parameters:
        `sql` - ignored
      Throws:
        `java.sql.SQLException` - always

    - #### executeQuery

          public java.sql.ResultSet executeQuery​(java.lang.String sql)
                                          throws java.sql.SQLException

      This method should always throw if called for a PreparedStatement or CallableStatement.
      Specified by:
        `executeQuery` in interface `java.sql.Statement`
      Parameters:
        `sql` - ignored
      Returns:
        nothing
      Throws:
        `java.sql.SQLException` - always

    - #### execute

          public boolean execute​(java.lang.String sql)
                          throws java.sql.SQLException

      This method should always throw if called for a PreparedStatement or CallableStatement.
      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - ignored
      Returns:
        nothing
      Throws:
        `java.sql.SQLException` - always

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql)
                            throws java.sql.SQLException

      This method should always throw if called for a PreparedStatement or CallableStatement.
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - ignored
      Returns:
        nothing
      Throws:
        `java.sql.SQLException` - always

    - #### close

          public void close()
                     throws java.sql.SQLException

      Does the specialized work required to free this object's resources and that of its parent class.
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### toString

          public java.lang.String toString()

      Retrieves a String representation of this object.

      The representation is of the form:

      class-name@hash[sql=[char-sequence], parameters=[p1, ...pi, ...pn]]

      p1, ...pi, ...pn are the String representations of the currently set parameter values that will be used with the non-batch execution methods.

      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a String representation of this object

    - #### setURL

          public void setURL​(int parameterIndex,
                             java.net.URL x)
                      throws java.sql.SQLException

      Sets the designated parameter to the given `java.net.URL` value. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

      HSQLDB-Specific Information:

      Including 2.0, HSQLDB does not support the DATALINK SQL type for which this method is intended. Calling this method throws an exception.
      Specified by:
        `setURL` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the `java.net.URL` object to be set
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQL 1.7.0

    - #### getParameterMetaData

          public java.sql.ParameterMetaData getParameterMetaData()
                                                          throws java.sql.SQLException

      Retrieves the number, types and properties of this `PreparedStatement` object's parameters.

      HSQLDB-Specific Information:

      Since 1.7.2, this feature is supported.
      Specified by:
        `getParameterMetaData` in interface `java.sql.PreparedStatement`
      Returns:
        a `ParameterMetaData` object that contains information about the number, types and properties for each parameter marker of this `PreparedStatement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.4, HSQL 1.7.0
      See Also:
        `ParameterMetaData`

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql,
                                   int autoGeneratedKeys)
                            throws java.sql.SQLException

      Statement methods that must be overridden in this class and throw an exception.
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### execute

          public boolean execute​(java.lang.String sql,
                                 int autoGeneratedKeys)
                          throws java.sql.SQLException

      Specified by:
        `execute` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql,
                                   int[] columnIndexes)
                            throws java.sql.SQLException

      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### execute

          public boolean execute​(java.lang.String sql,
                                 int[] columnIndexes)
                          throws java.sql.SQLException

      Specified by:
        `execute` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeUpdate

          public int executeUpdate​(java.lang.String sql,
                                   java.lang.String[] columnNames)
                            throws java.sql.SQLException

      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### execute

          public boolean execute​(java.lang.String sql,
                                 java.lang.String[] columnNames)
                          throws java.sql.SQLException

      Specified by:
        `execute` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### getMoreResults

          public boolean getMoreResults​(int current)
                                 throws java.sql.SQLException

      Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.

      There are no more results when the following is true:

               // stmt is a Statement object
               ((stmt.getMoreResults(current) == false) && (stmt.getUpdateCount() == -1))

      HSQLDB-Specific Information:

      HSQLDB supports this feature.

      This is used with CallableStatement objects that return multiple ResultSet objects.

      Specified by:
        `getMoreResults` in interface `java.sql.Statement`
      Parameters:
        `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSet`: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the argument supplied is not one of the following: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
      Since:
        JDK 1.4, HSQLDB 1.7
      See Also:
        `execute()`

    - #### getGeneratedKeys

          public java.sql.ResultSet getGeneratedKeys()
                                              throws java.sql.SQLException

      Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

      Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

      HSQLDB-Specific Information:

      Starting with version 2.0, HSQLDB supports this feature with single-row and multi-row insert, update and merge statements.

      This method returns a result set only if the executeUpdate methods that was used is one of the three methods that have the extra parameter indicating return of generated keys

      If the executeUpdate method did not specify the columns which represent the auto-generated keys the IDENTITY column or GENERATED column(s) of the table are returned.

      The executeUpdate methods with column indexes or column names return the post-insert or post-update values of the specified columns, whether the columns are generated or not. This allows values that have been modified by execution of triggers to be returned.

      If column names or indexes provided by the user in the executeUpdate() method calls do not correspond to table columns (incorrect names or indexes larger than the column count), an empty result is returned.

      Specified by:
        `getGeneratedKeys` in interface `java.sql.Statement`
      Returns:
        a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### getResultSetHoldability

          public int getResultSetHoldability()
                                      throws java.sql.SQLException

      Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
      Specified by:
        `getResultSetHoldability` in interface `java.sql.Statement`
      Returns:
        either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.4, HSQLDB 1.7

    - #### isClosed

          public boolean isClosed()

      Retrieves whether this `Statement` object has been closed. A `Statement` is closed if the method close has been called on it, or if it is automatically closed.
      Specified by:
        `isClosed` in interface `java.sql.Statement`
      Returns:
        true if this `Statement` object is closed; false if it is still open
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setRowId

          public void setRowId​(int parameterIndex,
                               java.sql.RowId x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.RowId` object. The driver converts this to a SQL `ROWID` value when it sends it to the database
      Specified by:
        `setRowId` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNString

          public void setNString​(int parameterIndex,
                                 java.lang.String value)
                          throws java.sql.SQLException

      Sets the designated parameter to the given `String` object. The driver converts this to a SQL `NCHAR` or `NVARCHAR` or `LONGNVARCHAR` value (depending on the argument's size relative to the driver's limits on `NVARCHAR` values) when it sends it to the database.
      Specified by:
        `setNString` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - of the first parameter is 1, the second is 2, ...
        `value` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNCharacterStream

          public void setNCharacterStream​(int parameterIndex,
                                          java.io.Reader value,
                                          long length)
                                   throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.
      Specified by:
        `setNCharacterStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - of the first parameter is 1, the second is 2, ...
        `value` - the parameter value
        `length` - the number of characters in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNClob

          public void setNClob​(int parameterIndex,
                               java.sql.NClob value)
                        throws java.sql.SQLException

      Sets the designated parameter to a `java.sql.NClob` object. The driver converts this to a SQL `NCLOB` value when it sends it to the database.
      Specified by:
        `setNClob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - of the first parameter is 1, the second is 2, ...
        `value` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setClob

          public void setClob​(int parameterIndex,
                              java.io.Reader reader,
                              long length)
                       throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`
      Specified by:
        `setClob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `reader` - An object that contains the data to set the parameter value to.
        `length` - the number of characters in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if the length specified is less than zero.
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setBlob

          public void setBlob​(int parameterIndex,
                              java.io.InputStream inputStream,
                              long length)
                       throws java.sql.SQLException

      Sets the designated parameter to a `InputStream` object. The `Inputstream` must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setBinaryStream (int, InputStream, int)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

      HSQLDB-Specific Information:

      In HSQLDB 2.0, this method uses streaming to send the data when the stream is assigned to a BLOB target. For other binary targets the stream is read on the client side and a byte array is sent.
      Specified by:
        `setBlob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `inputStream` - An object that contains the data to set the parameter value to.
        `length` - the number of bytes in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement`; if the length specified is less than zero or if the number of bytes in the `InputStream` does not match the specified length.
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNClob

          public void setNClob​(int parameterIndex,
                               java.io.Reader reader,
                               long length)
                        throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`
      Specified by:
        `setNClob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `reader` - An object that contains the data to set the parameter value to.
        `length` - the number of characters in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the length specified is less than zero; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setSQLXML

          public void setSQLXML​(int parameterIndex,
                                java.sql.SQLXML xmlObject)
                         throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.SQLXML` object. The driver converts this to an SQL `XML` value when it sends it to the database.
      Specified by:
        `setSQLXML` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `xmlObject` - a `SQLXML` object that maps an SQL `XML` value
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `PreparedStatement` or the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setObject

          public void setObject​(int parameterIndex,
                                java.lang.Object x,
                                int targetSqlType,
                                int scaleOrLength)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the prepared statement is executed.

      The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

      Note that this method may be used to pass database-specific abstract data types.

      Specified by:
        `setObject` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the object containing the input parameter value
        `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
        `scaleOrLength` - for `java.sql.Types.DECIMAL` or `java.sql.Types.NUMERIC types`, this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if the Java Object specified by x is an InputStream or Reader object and the value of the scale parameter is less than zero
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
      See Also:
        `Types`

    - #### setAsciiStream

          public void setAsciiStream​(int parameterIndex,
                                     java.io.InputStream x,
                                     long length)
                              throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      From HSQLDB 2.0 this method uses the US-ASCII character encoding to convert bytes from the stream into the characters of a String.

      This method does not use streaming to send the data, whether the target is a CLOB or other binary object.

      For long streams (larger than a few megabytes) with CLOB targets, it is more efficient to use a version of setCharacterStream which takes the a length parameter.

      Specified by:
        `setAsciiStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the Java input stream that contains the ASCII parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setBinaryStream

          public void setBinaryStream​(int parameterIndex,
                                      java.io.InputStream x,
                                      long length)
                               throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      This method uses streaming to send the data when the stream is assigned to a BLOB target. For other binary targets the stream is read on the client side and a byte array is sent.
      Specified by:
        `setBinaryStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the java input stream which contains the binary parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setCharacterStream

          public void setCharacterStream​(int parameterIndex,
                                         java.io.Reader reader,
                                         long length)
                                  throws java.sql.SQLException

      Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      HSQLDB-Specific Information:

      This method uses streaming to send data when the target is a CLOB.
      Specified by:
        `setCharacterStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `reader` - the `java.io.Reader` object that contains the Unicode data
        `length` - the number of characters in the stream
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setAsciiStream

          public void setAsciiStream​(int parameterIndex,
                                     java.io.InputStream x)
                              throws java.sql.SQLException

      Sets the designated parameter to the given input stream. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setAsciiStream` which takes a length parameter.

      HSQLDB-Specific Information:

      In HSQLDB 2.0, this method does not use streaming to send the data, whether the target is a CLOB or other binary object. For long streams (larger than a few megabytes), it is more efficient to use a version of setCharacterStream which takes the a length parameter.
      Specified by:
        `setAsciiStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the Java input stream that contains the ASCII parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### setBinaryStream

          public void setBinaryStream​(int parameterIndex,
                                      java.io.InputStream x)
                               throws java.sql.SQLException

      Sets the designated parameter to the given input stream. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBinaryStream` which takes a length parameter.

      HSQLDB-Specific Information:

      This method does not use streaming to send the data, whether the target is a CLOB or other binary object.

      For long streams (larger than a few megabytes) with CLOB targets, it is more efficient to use a version of setCharacterStream which takes the a length parameter.

      Specified by:
        `setBinaryStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the java input stream which contains the binary parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### setCharacterStream

          public void setCharacterStream​(int parameterIndex,
                                         java.io.Reader reader)
                                  throws java.sql.SQLException

      Sets the designated parameter to the given `Reader` object. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setCharacterStream` which takes a length parameter.

      HSQLDB-Specific Information:

      In HSQLDB 2.0, this method does not use streaming to send the data, whether the target is a CLOB or other binary object. For long streams (larger than a few megabytes), it is more efficient to use a version of setCharacterStream which takes the a length parameter.
      Specified by:
        `setCharacterStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `reader` - the `java.io.Reader` object that contains the Unicode data
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### setNCharacterStream

          public void setNCharacterStream​(int parameterIndex,
                                          java.io.Reader value)
                                   throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNCharacterStream` which takes a length parameter.

      Specified by:
        `setNCharacterStream` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - of the first parameter is 1, the second is 2, ...
        `value` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### setClob

          public void setClob​(int parameterIndex,
                              java.io.Reader reader)
                       throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setClob` which takes a length parameter.

      Specified by:
        `setClob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `reader` - An object that contains the data to set the parameter value to.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement`or if parameterIndex does not correspond to a parameter marker in the SQL statement
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### setBlob

          public void setBlob​(int parameterIndex,
                              java.io.InputStream inputStream)
                       throws java.sql.SQLException

      Sets the designated parameter to a `InputStream` object. This method differs from the `setBinaryStream (int, InputStream)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBlob` which takes a length parameter.

      Specified by:
        `setBlob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `inputStream` - An object that contains the data to set the parameter value to.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if parameterIndex does not correspond to a parameter marker in the SQL statement,
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### setNClob

          public void setNClob​(int parameterIndex,
                               java.io.Reader reader)
                        throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNClob` which takes a length parameter.

      Specified by:
        `setNClob` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
        `reader` - An object that contains the data to set the parameter value to.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.6

    - #### getMaxFieldSize

          public int getMaxFieldSize()
                              throws java.sql.SQLException

      Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

      HSQLDB-Specific Information:

      HSQLDB always returns zero, meaning there is no limit.
      Specified by:
        `getMaxFieldSize` in interface `java.sql.Statement`
      Returns:
        the current column size limit for columns storing character and binary values; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `setMaxFieldSize(int)`

    - #### setMaxFieldSize

          public void setMaxFieldSize​(int max)
                               throws java.sql.SQLException

      Sets the limit for the maximum number of bytes in a `ResultSet` Sets the limit for the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, `NCHAR`, `NVARCHAR`, `LONGNVARCHAR` and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.

      HSQLDB-Specific Information:

      To present, calls to this method are simply ignored; HSQLDB always stores the full number of bytes when dealing with any of the field types mentioned above. These types all have an absolute maximum element upper bound determined by the Java array index limit java.lang.Integer.MAX_VALUE. For XXXBINARY types, this translates to Integer.MAX_VALUE bytes. For XXXCHAR types, this translates to 2 * Integer.MAX_VALUE bytes (2 bytes / character).

      In practice, field sizes are limited to values much smaller than the absolute maximum element upper bound, in particular due to limits imposed on the maximum available Java heap memory.

      Specified by:
        `setMaxFieldSize` in interface `java.sql.Statement`
      Parameters:
        `max` - the new column size limit in bytes; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
      See Also:
        `getMaxFieldSize()`

    - #### getMaxRows

          public int getMaxRows()
                         throws java.sql.SQLException

      Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.
      Specified by:
        `getMaxRows` in interface `java.sql.Statement`
      Returns:
        the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `setMaxRows(int)`

    - #### setMaxRows

          public void setMaxRows​(int max)
                          throws java.sql.SQLException

      Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.
      Specified by:
        `setMaxRows` in interface `java.sql.Statement`
      Parameters:
        `max` - the new max rows limit; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
      See Also:
        `getMaxRows()`

    - #### getQueryTimeout

          public int getQueryTimeout()
                              throws java.sql.SQLException

      Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

      HSQLDB-Specific Information:

      To present, HSQLDB always returns zero, meaning there is no limit.
      Specified by:
        `getQueryTimeout` in interface `java.sql.Statement`
      Returns:
        the current query timeout limit in seconds; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `setQueryTimeout(int)`

    - #### setQueryTimeout

          public void setQueryTimeout​(int seconds)
                               throws java.sql.SQLException

      Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown. A JDBC driver must apply this limit to the `execute`, `executeQuery` and `executeUpdate` methods. JDBC driver implementations may also apply this limit to `ResultSet` methods (consult your driver vendor documentation for details).

      HSQLDB-Specific Information:

      The maximum number of seconds to wait is 32767.
      Specified by:
        `setQueryTimeout` in interface `java.sql.Statement`
      Parameters:
        `seconds` - the new query timeout limit in seconds; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `seconds >= 0` is not satisfied
      See Also:
        `getQueryTimeout()`

    - #### cancel

          public void cancel()
                      throws java.sql.SQLException

      Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

      HSQLDB-Specific Information:

      HSQLDB version 2.3.4 and later supports aborting an SQL query or data update statement.
      Specified by:
        `cancel` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

    - #### getWarnings

          public java.sql.SQLWarning getWarnings()
                                          throws java.sql.SQLException

      Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

      The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

      Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

      HSQLDB-Specific Information:

      From 1.9 HSQLDB, produces Statement warnings.
      Specified by:
        `getWarnings` in interface `java.sql.Statement`
      Returns:
        the first `SQLWarning` object or `null` if there are no warnings
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`

    - #### clearWarnings

          public void clearWarnings()
                             throws java.sql.SQLException

      Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

      HSQLDB-Specific Information:

      Supported in HSQLDB 1.9.
      Specified by:
        `clearWarnings` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`

    - #### setCursorName

          public void setCursorName​(java.lang.String name)
                             throws java.sql.SQLException

      Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To ensure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

      Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

      HSQLDB-Specific Information:

      Including 2.0, HSQLDB does not support named cursors; calls to this method are ignored.
      Specified by:
        `setCursorName` in interface `java.sql.Statement`
      Parameters:
        `name` - the new cursor name, which must be unique within a connection
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

    - #### getResultSet

          public java.sql.ResultSet getResultSet()
                                          throws java.sql.SQLException

      Retrieves the current result as a `ResultSet` object. This method should be called only once per result.

      HSQLDB-Specific Information:

      Without an interceding call to executeXXX, each invocation of this method will produce a new, initialized ResultSet instance referring to the current result, if any.
      Specified by:
        `getResultSet` in interface `java.sql.Statement`
      Returns:
        the current result as a `ResultSet` object or `null` if the result is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `execute()`

    - #### getUpdateCount

          public int getUpdateCount()
                             throws java.sql.SQLException

      Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.
      Specified by:
        `getUpdateCount` in interface `java.sql.Statement`
      Returns:
        the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `execute()`

    - #### getMoreResults

          public boolean getMoreResults()
                                 throws java.sql.SQLException

      Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.

      There are no more results when the following is true:

               // stmt is a Statement object
               ((stmt.getMoreResults() == false) && (stmt.getUpdateCount() == -1))

      Specified by:
        `getMoreResults` in interface `java.sql.Statement`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `execute()`

    - #### setFetchDirection

          public void setFetchDirection​(int direction)
                                 throws java.sql.SQLException

      Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

      Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

      HSQLDB-Specific Information:

      Up to 1.8.0.x, HSQLDB supports only `FETCH_FORWARD`; Setting any other value would throw an `SQLException` stating that the operation is not supported.

      Starting with 2.0, HSQLDB accepts any valid value.

      Specified by:
        `setFetchDirection` in interface `java.sql.Statement`
      Parameters:
        `direction` - the initial direction for processing rows
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the given direction is not one of `ResultSet.FETCH_FORWARD`, `ResultSet.FETCH_REVERSE`, or `ResultSet.FETCH_UNKNOWN`
      Since:
        JDK 1.2
      See Also:
        `getFetchDirection()`

    - #### getFetchDirection

          public int getFetchDirection()
                                throws java.sql.SQLException

      Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

      HSQLDB-Specific Information:

      Up to 1.8.0.x, HSQLDB always returned FETCH_FORWARD. Starting with 2.0, HSQLDB returns FETCH_FORWARD by default, or whatever value has been explicitly assigned by invoking `setFetchDirection`. .
      Specified by:
        `getFetchDirection` in interface `java.sql.Statement`
      Returns:
        the default fetch direction for result sets generated from this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2
      See Also:
        `setFetchDirection(int)`

    - #### setFetchSize

          public void setFetchSize​(int rows)
                            throws java.sql.SQLException

      Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects generated by this `Statement`. If the value specified is zero, then the hint is ignored. The default value is zero.

      HSQLDB-Specific Information:

      HSQLDB uses the specified value as a hint, but may process more or fewer rows than specified.
      Specified by:
        `setFetchSize` in interface `java.sql.Statement`
      Parameters:
        `rows` - the number of rows to fetch
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `{@code rows >= 0}` is not satisfied.
      Since:
        JDK 1.2
      See Also:
        `getFetchSize()`

    - #### getFetchSize

          public int getFetchSize()
                           throws java.sql.SQLException

      Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.
      HSQLDB-Specific Information

      HSQLDB returns 0 by default, or the fetch size specified by setFetchSize

      Specified by:
        `getFetchSize` in interface `java.sql.Statement`
      Returns:
        the default fetch size for result sets generated from this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2
      See Also:
        `setFetchSize(int)`

    - #### getResultSetConcurrency

          public int getResultSetConcurrency()
                                      throws java.sql.SQLException

      Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

      HSQLDB-Specific Information:

      HSQLDB supports `CONCUR_READ_ONLY` and `CONCUR_READ_UPDATEBLE` concurrency.
      Specified by:
        `getResultSetConcurrency` in interface `java.sql.Statement`
      Returns:
        either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2

    - #### getResultSetType

          public int getResultSetType()
                               throws java.sql.SQLException

      Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

      HSQLDB-Specific Information:

      HSQLDB 1.7.0 and later versions support `TYPE_FORWARD_ONLY` and `TYPE_SCROLL_INSENSITIVE`.
      Specified by:
        `getResultSetType` in interface `java.sql.Statement`
      Returns:
        one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2

    - #### clearBatch

          public void clearBatch()
                          throws java.sql.SQLException

      Empties this `Statement` object's current list of SQL commands.

      NOTE: Support of an ability to batch updates is optional.

      HSQLDB-Specific Information:

      Starting with HSQLDB 1.7.2, this feature is supported.
      Specified by:
        `clearBatch` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
      Since:
        JDK 1.2
      See Also:
        `addBatch()`

    - #### getConnection

          public java.sql.Connection getConnection()
                                            throws java.sql.SQLException

      Retrieves the `Connection` object that produced this `Statement` object.
      Specified by:
        `getConnection` in interface `java.sql.Statement`
      Returns:
        the connection that produced this statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        JDK 1.2

    - #### setPoolable

          public void setPoolable​(boolean poolable)
                           throws java.sql.SQLException

      Requests that a `Statement` be pooled or not pooled. The value specified is a hint to the statement pool implementation indicating whether the application wants the statement to be pooled. It is up to the statement pool manager as to whether the hint is used.

      The poolable value of a statement is applicable to both internal statement caches implemented by the driver and external statement caches implemented by application servers and other applications.

      By default, a `Statement` is not poolable when created, and a `PreparedStatement` and `CallableStatement` are poolable when created.

      Specified by:
        `setPoolable` in interface `java.sql.Statement`
      Parameters:
        `poolable` - requests that the statement be pooled if true and that the statement not be pooled if false
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### isPoolable

          public boolean isPoolable()
                             throws java.sql.SQLException

      Returns a value indicating whether the `Statement` is poolable or not.
      Specified by:
        `isPoolable` in interface `java.sql.Statement`
      Returns:
        `true` if the `Statement` is poolable; `false` otherwise
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`
      Since:
        JDK 1.6, HSQLDB 2.0
      See Also:
        `setPoolable(boolean)`

    - #### unwrap

          public <T> T unwrap​(java.lang.Class<T> iface)
                       throws java.sql.SQLException

      Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.
      Specified by:
        `unwrap` in interface `java.sql.Wrapper`
      Parameters:
        `iface` - A Class defining an interface that the result must implement.
      Returns:
        an object that implements the interface. May be a proxy for the actual implementing object.
      Throws:
        `java.sql.SQLException` - If no object found that implements the interface
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### isWrapperFor

          public boolean isWrapperFor​(java.lang.Class<?> iface)
                               throws java.sql.SQLException

      Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.
      Specified by:
        `isWrapperFor` in interface `java.sql.Wrapper`
      Parameters:
        `iface` - a Class defining an interface.
      Returns:
        true if this implements the interface or directly or indirectly wraps an object that does.
      Throws:
        `java.sql.SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getLargeUpdateCount

          public long getLargeUpdateCount()
                                   throws java.sql.SQLException

      Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      The public implementation will throw `UnsupportedOperationException`

      Specified by:
        `getLargeUpdateCount` in interface `java.sql.Statement`
      Returns:
        the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        1.8
      See Also:
        `execute()`

    - #### setLargeMaxRows

          public void setLargeMaxRows​(long max)
                               throws java.sql.SQLException

      Sets the limit for the maximum number of rows that any `ResultSet` object generated by this `Statement` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

      This method should be used when the row limit may exceed `Integer.MAX_VALUE`.

      The default implementation will throw `UnsupportedOperationException`

      Specified by:
        `setLargeMaxRows` in interface `java.sql.Statement`
      Parameters:
        `max` - the new max rows limit; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `max >= 0` is not satisfied
      Since:
        1.8
      See Also:
        `getMaxRows()`

    - #### getLargeMaxRows

          public long getLargeMaxRows()
                               throws java.sql.SQLException

      Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

      This method should be used when the returned row limit may exceed `Integer.MAX_VALUE`.

      The default implementation will return `0`

      Specified by:
        `getLargeMaxRows` in interface `java.sql.Statement`
      Returns:
        the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        1.8
      See Also:
        `setMaxRows(int)`

    - #### executeLargeBatch

          public long[] executeLargeBatch()
                                   throws java.sql.SQLException

      Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `long` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeLargeBatch` may be one of the following:
      1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
      2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

         If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getLargeUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

      3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      The default implementation will throw `UnsupportedOperationException`

      Specified by:
        `executeLargeBatch` in interface `java.sql.Statement`
      Returns:
        an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8
      See Also:
        `addBatch()`, `DatabaseMetaData.supportsBatchUpdates()`

    - #### setObject

          public void setObject​(int parameterIndex,
                                java.lang.Object x,
                                java.sql.SQLType targetSqlType,
                                int scaleOrLength)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the prepared statement is executed.

      The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

      Note that this method may be used to pass database-specific abstract data types.

      The default implementation will throw `SQLFeatureNotSupportedException`

      Specified by:
        `setObject` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the object containing the input parameter value
        `targetSqlType` - the SQL type to be sent to the database. The scale argument may further qualify this type.
        `scaleOrLength` - for `java.sql.JDBCType.DECIMAL` or `java.sql.JDBCType.NUMERIC types`, this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement` or if the Java Object specified by x is an InputStream or Reader object and the value of the scale parameter is less than zero
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
      Since:
        1.8
      See Also:
        `JDBCType`, `SQLType`

    - #### setObject

          public void setObject​(int parameterIndex,
                                java.lang.Object x,
                                java.sql.SQLType targetSqlType)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. This method is similar to `setObject(int parameterIndex, Object x, SQLType targetSqlType, int scaleOrLength)`, except that it assumes a scale of zero.

      The default implementation will throw `SQLFeatureNotSupportedException`

      Specified by:
        `setObject` in interface `java.sql.PreparedStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
        `x` - the object containing the input parameter value
        `targetSqlType` - the SQL type to be sent to the database
      Throws:
        `java.sql.SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
      Since:
        1.8
      See Also:
        `JDBCType`, `SQLType`

    - #### executeLargeUpdate

          public long executeLargeUpdate()
                                  throws java.sql.SQLException

      Executes the SQL statement in this `PreparedStatement` object, which must be an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.

      This method should be used when the returned row count may exceed `Integer.MAX_VALUE`.

      The default implementation will throw `UnsupportedOperationException`

      Specified by:
        `executeLargeUpdate` in interface `java.sql.PreparedStatement`
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or the SQL statement returns a `ResultSet` object
        `java.sql.SQLTimeoutException` - when the driver has determined that the timeout value that was specified by the `setQueryTimeout` method has been exceeded and has at least attempted to cancel the currently running `Statement`
      Since:
        1.8

    - #### getSQL

          public java.lang.String getSQL()

    - #### getStatementID

          public long getStatementID()

    - #### isRowCount

          public boolean isRowCount()

    - #### getResultSetMetaData

          public JDBCResultSetMetaData getResultSetMetaData()

    - #### getParameterMetaDataDirect

          public org.hsqldb.result.ResultMetaData getParameterMetaDataDirect()

    - #### closeOnCompletion

          public void closeOnCompletion()
                                 throws java.sql.SQLException

      Specifies that this `Statement` will be closed when all its dependent result sets are closed. If execution of the `Statement` does not produce any result sets, this method has no effect.

      Note: Multiple calls to `closeOnCompletion` do not toggle the effect on this `Statement`. However, a call to `closeOnCompletion` does effect both the subsequent execution of statements, and statements that currently have open, dependent, result sets.

      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`
      Since:
        JDK 1.7, HSQLDB 2.0.1

    - #### isCloseOnCompletion

          public boolean isCloseOnCompletion()
                                      throws java.sql.SQLException

      Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
      Returns:
        `true` if the `Statement` will be closed when all of its dependent result sets are closed; `false` otherwise
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`
      Since:
        JDK 1.7, HSQLDB 2.0.1